OpenVDB: LeafData< ValueMask, CoordT, MaskT, LOG2DIM > Struct Template Reference

OpenVDB 12.0.0 |

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
LeafData< ValueMask, CoordT, MaskT, LOG2DIM > Struct Template Reference

`#include <nanovdb/NanoVDB.h>`

## Public Types
using | ValueType = bool
using | BuildType = ValueMask
using | FloatType = bool
using | ArrayType = void
using | ValueType
using | BuildType
using | FloatType
using | ArrayType

## Public Member Functions
__hostdev__ bool | getValue (uint32_t i) const
__hostdev__ bool | getMin () const
__hostdev__ bool | getMax () const
__hostdev__ bool | getAvg () const
__hostdev__ bool | getDev () const
__hostdev__ void | setValue (uint32_t offset, bool)
__hostdev__ void | setOn (uint32_t offset)
__hostdev__ void | setMin (const ValueType &)
__hostdev__ void | setMax (const ValueType &)
__hostdev__ void | setAvg (const FloatType &)
__hostdev__ void | setDev (const FloatType &)
template<typename T>
__hostdev__ void | setOrigin (const T &ijk)
| LeafData ()=delete
| This class cannot be constructed or deleted.
| LeafData (const LeafData &)=delete
LeafData & | operator= (const LeafData &)=delete
| ~LeafData ()=delete
__hostdev__ ValueType | getValue (uint32_t i) const
__hostdev__ void | setValueOnly (uint32_t offset, const ValueType &value)
__hostdev__ void | setValue (uint32_t offset, const ValueType &value)
__hostdev__ void | setOn (uint32_t offset)
__hostdev__ ValueType | getMin () const
__hostdev__ ValueType | getMax () const
__hostdev__ FloatType | getAvg () const
__hostdev__ FloatType | getDev () const
__hostdev__ void | setMin (const ValueType &v)
__hostdev__ void | setMax (const ValueType &v)
__hostdev__ void | setAvg (const FloatType &v)
__hostdev__ void | setDev (const FloatType &v)
__hostdev__ void | setOrigin (const T &ijk)
__hostdev__ void | fill (const ValueType &v)
| LeafData ()=delete
| This class cannot be constructed or deleted.
| LeafData (const LeafData &)=delete
LeafData & | operator= (const LeafData &)=delete
| ~LeafData ()=delete

## Static Public Member Functions
static __hostdev__ uint64_t | memUsage ()
static __hostdev__ bool | hasStats ()
static __hostdev__ constexpr uint32_t | padding ()
static __hostdev__ constexpr uint32_t | padding ()
| Return padding of this class in bytes, due to aliasing and 32B alignment.
static __hostdev__ uint64_t | memUsage ()
static __hostdev__ bool | hasStats ()

## Public Attributes
CoordT | mBBoxMin
uint8_t | mBBoxDif [3]
uint8_t | mFlags
MaskT< LOG2DIM > | mValueMask
uint64_t | mPadding [2]
CoordT | mBBoxMin
uint8_t | mBBoxDif [3]
uint8_t | mFlags
MaskT< LOG2DIM > | mValueMask
ValueType | mMinimum
ValueType | mMaximum
FloatType | mAverage
FloatType | mStdDevi
ValueType | mValues [1u<< 3 *LOG2DIM]

## Static Public Attributes
static constexpr bool | FIXED_SIZE = true
static constexpr bool | FIXED_SIZE

## Member Typedef Documentation

## ◆ ArrayType [1/2]

using ArrayType

## ◆ ArrayType [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using ArrayType = void

## ◆ BuildType [1/2]

using BuildType

## ◆ BuildType [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BuildType = ValueMask

## ◆ FloatType [1/2]

using FloatType

## ◆ FloatType [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using FloatType = bool

## ◆ ValueType [1/2]

using ValueType

## ◆ ValueType [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using ValueType = bool

## Constructor & Destructor Documentation

## ◆ LeafData() [1/4]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( |  | ) |
| delete

This class cannot be constructed or deleted.

## ◆ LeafData() [2/4]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( | const LeafData< ValueMask, CoordT, MaskT, LOG2DIM > & |  | ) |
| delete

## ◆ ~LeafData() [1/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

~LeafData | ( |  | ) |
| delete

## ◆ LeafData() [3/4]

LeafData | ( |  | ) |
| delete

This class cannot be constructed or deleted.

## ◆ LeafData() [4/4]

LeafData | ( | const LeafData< ValueMask, CoordT, MaskT, LOG2DIM > & |  | ) |
| delete

## ◆ ~LeafData() [2/2]

~LeafData | ( |  | ) |
| delete

## Member Function Documentation

## ◆ fill()

__hostdev__ void fill | ( | const ValueType & | v | ) |
| inline

## ◆ getAvg() [1/2]

__hostdev__ FloatType getAvg | ( |  | ) | const
| inline

## ◆ getAvg() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

__hostdev__ bool getAvg | ( |  | ) | const
| inline

## ◆ getDev() [1/2]

__hostdev__ FloatType getDev | ( |  | ) | const
| inline

## ◆ getDev() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

__hostdev__ bool getDev | ( |  | ) | const
| inline

## ◆ getMax() [1/2]

__hostdev__ ValueType getMax | ( |  | ) | const
| inline

## ◆ getMax() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

__hostdev__ bool getMax | ( |  | ) | const
| inline

## ◆ getMin() [1/2]

__hostdev__ ValueType getMin | ( |  | ) | const
| inline

## ◆ getMin() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

__hostdev__ bool getMin | ( |  | ) | const
| inline

## ◆ getValue() [1/2]

__hostdev__ ValueType getValue | ( | uint32_t | i | ) | const
| inline

## ◆ getValue() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

__hostdev__ bool getValue | ( | uint32_t | i | ) | const
| inline

## ◆ hasStats() [1/2]

static __hostdev__ bool hasStats | ( |  | ) |
| inlinestatic

## ◆ hasStats() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

static __hostdev__ bool hasStats | ( |  | ) |
| inlinestatic

## ◆ memUsage() [1/2]

static __hostdev__ uint64_t memUsage | ( |  | ) |
| inlinestatic

## ◆ memUsage() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

static __hostdev__ uint64_t memUsage | ( |  | ) |
| inlinestatic

## ◆ operator=() [1/2]

LeafData & operator= | ( | const LeafData< ValueMask, CoordT, MaskT, LOG2DIM > & |  | ) |
| delete

## ◆ operator=() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData & operator= | ( | const LeafData< ValueMask, CoordT, MaskT, LOG2DIM > & |  | ) |
| delete

## ◆ padding() [1/2]

static __hostdev__ constexpr uint32_t padding | ( |  | ) |
| inlinestaticconstexpr

Return padding of this class in bytes, due to aliasing and 32B alignment.

Note
  The extra bytes are not necessarily at the end, but can come from aliasing of individual data members.

## ◆ padding() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

static __hostdev__ constexpr uint32_t padding | ( |  | ) |
| inlinestaticconstexpr

## ◆ setAvg() [1/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

__hostdev__ void setAvg | ( | const FloatType & |  | ) |
| inline

## ◆ setAvg() [2/2]

__hostdev__ void setAvg | ( | const FloatType & | v | ) |
| inline

## ◆ setDev() [1/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

__hostdev__ void setDev | ( | const FloatType & |  | ) |
| inline

## ◆ setDev() [2/2]

__hostdev__ void setDev | ( | const FloatType & | v | ) |
| inline

## ◆ setMax() [1/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

__hostdev__ void setMax | ( | const ValueType & |  | ) |
| inline

## ◆ setMax() [2/2]

__hostdev__ void setMax | ( | const ValueType & | v | ) |
| inline

## ◆ setMin() [1/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

__hostdev__ void setMin | ( | const ValueType & |  | ) |
| inline

## ◆ setMin() [2/2]

__hostdev__ void setMin | ( | const ValueType & | v | ) |
| inline

## ◆ setOn() [1/2]

__hostdev__ void setOn | ( | uint32_t | offset | ) |
| inline

## ◆ setOn() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

__hostdev__ void setOn | ( | uint32_t | offset | ) |
| inline

## ◆ setOrigin() [1/2]

__hostdev__ void setOrigin | ( | const T & | ijk | ) |
| inline

## ◆ setOrigin() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>
template<typename T>

__hostdev__ void setOrigin | ( | const T & | ijk | ) |
| inline

## ◆ setValue() [1/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

__hostdev__ void setValue | ( | uint32_t | offset,
|  | bool | )
| inline

## ◆ setValue() [2/2]

__hostdev__ void setValue | ( | uint32_t | offset,
|  | const ValueType & | value )
| inline

## ◆ setValueOnly()

__hostdev__ void setValueOnly | ( | uint32_t | offset,
|  | const ValueType & | value )
| inline

## Member Data Documentation

## ◆ FIXED_SIZE [1/2]

bool FIXED_SIZE
| staticconstexpr

## ◆ FIXED_SIZE [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

bool FIXED_SIZE = true
| staticconstexpr

## ◆ mAverage

FloatType mAverage

## ◆ mBBoxDif [1/2]

uint8_t mBBoxDif[3]

## ◆ mBBoxDif [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint8_t mBBoxDif[3]

## ◆ mBBoxMin [1/2]

CoordT mBBoxMin

## ◆ mBBoxMin [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

CoordT mBBoxMin

## ◆ mFlags [1/2]

uint8_t mFlags

## ◆ mFlags [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint8_t mFlags

## ◆ mMaximum

ValueType mMaximum

## ◆ mMinimum

ValueType mMinimum

## ◆ mPadding

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t mPadding[2]

## ◆ mStdDevi

FloatType mStdDevi

## ◆ mValueMask [1/2]

MaskT<LOG2DIM> mValueMask

## ◆ mValueMask [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

MaskT<LOG2DIM> mValueMask

## ◆ mValues

ValueType mValues[1u<< 3 *LOG2DIM]